package Format;

my $pkg="Format";

use strict;
use My;
use Info;
use Class::Date qw(date);


#======== Hlavni formatovaci funkce - obecne
#- formatovani cisla
sub formatNumber {
   my ($pkg_p, $number,$prefix,$thous,$dec,$postfix)=@_;
   my ($numberT,$numberD);
   if(!defined($dec)) {
      ($numberT,$numberD)=split(/\./,$number);
      $dec=length($numberD);
   }
   elsif($dec>=0) {
      ($numberT,$numberD)=split(/\./,sprintf("%.${dec}f",$number));
   }
   else {
      ($numberT,$numberD)=split(/\./,sprintf("%.0f", $number * (10**$dec) ) );
   }
   my $sign;
   if($numberT<0) {
      $sign="-";
      $numberT*=-1;
   }
   else {
      $sign="";
   }
   if($thous and (my $lenT=length($numberT))>3) {
      my $tsep;
      if(get_env("lang") eq "en") {
         $tsep=",";
      }
      else {
         $tsep=" ";
      }
      if($lenT<7) {
         $numberT=~s/^(\d+)(\d{3})$/${1}${tsep}${2}/;
      }
      elsif($lenT<10) {
         $numberT=~s/^(\d+)(\d{3})(\d{3})$/${1}${tsep}${2}${tsep}${3}/;
      }
      else {
         $numberT=~s/^(\d+)(\d{3})(\d{3})(\d{3})$/${1}${tsep}${2}${tsep}${3}${tsep}${4}/;
      }
   }
   if($dec>0) {
      $number=$sign.$numberT.".".$numberD;
   }
   else {
      $number=$sign.$numberT;
   }
   return $prefix . $number . $postfix;
}

#- funkce prevadejici retezec pro formatovani cisla uzivany v XML na retezec uzivany funkci perlu
sub formatNumber_covert {
   my ($pkg_p, $format)=@_;
   my ($prefix,$thous,$dec,$postfix);
   $format=~/^([^\#0]*)([\#0\,]*)\.{0,1}([\#0]*)([^\#0]*)$/;
   $prefix=$1; $prefix=~s/\\\%/\%/g;
   my $thoustext=$2;
   my $dectext=$3;
   $postfix=$4; $postfix=~s/\\\%/\%/g;
   # tisice (poznamka: $thous==1 - oddelovat tisice; $thous==0 - neoddelovat tisice)
   my $thouslength;
   if($thoustext=~/^.*\,([\#0]*)$/) {
      $thouslength=length($1);
   }
   if(defined($thouslength)) {
      $thous=1;
   }
   else {
      $thous=0;
   }
   # desetiny
   if(length($dectext)) {
      $dec=length($dectext);
   }
   elsif(defined($thouslength)) {
      $dec=$thouslength-3;
   }
   return ($prefix,$thous,$dec,$postfix);
}

#- formatovani data
sub formatDate {
   my ($pkg_p, $date,$format)=@_;
   $date=~s/T/ /;
   my $datestr;
   if($date=~/^0000-00-00/) {
      $datestr="-";
   }
   else {
      $datestr=date($date)->strftime($format);
   }
   return $datestr;
}

#- funkce prevadejici retezec pro formatovani data ci casu uzivany v XML na retezec uzivany funkci perlu
sub formatDate_covert {
   my ($pkg_p, $format)=@_;
   $format=~s/yyyy/\%Y/g;
   $format=~s/yy/\%y/g;
   $format=~s/MMMM/\%B/g;
   $format=~s/MMM/\%b/g;
   $format=~s/MM/\%m/g;
   $format=~s/M/\%m/g; # tohle neni uplne ok, jelikoz %m vraci 01 az 12 a ne 1 az 12, coz bych chtel
   $format=~s/dddd/\%A/g;
   $format=~s/ddd/\%a/g;
   $format=~s/dd/\%D/g;
   $format=~s/d/\%e/g;
   $format=~s/\%D/\%d/g; # opravicka predchoziho nahrazeni
   $format=~s/hh/\%H/g;
   $format=~s/h/\%k/g;
   $format=~s/mm/\%M/g; # ke kolizi s %m by nemelo dojit
   $format=~s/ss/\%S/g;
   return ($format);
}

return 1;

